"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.post = void 0;
const axios_1 = __importDefault(require("axios"));
const utils_1 = require("../utils/utils");
const post = (appRequest, appResponse) => __awaiter(void 0, void 0, void 0, function* () {
    var _a, _b, _c, _d;
    (0, utils_1.appLog)("POST => " + appRequest.url);
    try {
        const response = yield axios_1.default.post(appRequest.url, appRequest.data);
        (0, utils_1.appLog)(`POST <= ${response.status} ${appRequest.url}`);
        (0, utils_1.appLog)(`RESPONSE <= ${JSON.stringify(response.data)}`);
        appResponse.onSuccess(response.data);
    }
    catch (error) {
        if (!error.response) {
            error.response = {
                status: 500,
                data: {
                    error: "server_error",
                    error_description: "Something is Wrong",
                },
            };
        }
        else {
            if (!error.response.data.error_description) {
                error.response.data.error_description = error.response.data.error;
            }
        }
        (0, utils_1.appLog)(`POST <= ${error.response.status} ${appRequest.url}`);
        (0, utils_1.appLog)(`RESPONSE ERROR <= ${JSON.stringify(error.response.data)}`);
        if (axios_1.default.isAxiosError(error)) {
            if (((_a = error.response) === null || _a === void 0 ? void 0 : _a.status) == 401 && appResponse.onUnauthorized) {
                return appResponse.onUnauthorized();
            }
            if (((_b = error.response) === null || _b === void 0 ? void 0 : _b.status) == 403 && appResponse.onForbidden) {
                return appResponse.onForbidden();
            }
            if (((_c = error.response) === null || _c === void 0 ? void 0 : _c.status) == 404 && appResponse.onNotFound) {
                return appResponse.onNotFound();
            }
        }
        return appResponse.onFailure((_d = error.response) === null || _d === void 0 ? void 0 : _d.data.error_description);
    }
});
exports.post = post;
