"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getInitialData = exports.updateAccessToken = exports.getAccessToken = exports.saveInitialData = void 0;
const fs_1 = __importDefault(require("fs"));
const utils_1 = require("../utils/utils");
const storagePath = "./storage/";
const storageFile = "storage.json";
const saveInitialData = (initialData) => {
    if (!fs_1.default.existsSync(storagePath)) {
        fs_1.default.mkdirSync(storagePath);
    }
    fs_1.default.writeFileSync(storagePath + storageFile, JSON.stringify(initialData));
    (0, utils_1.appLog)("Initial file saved/updated successfully");
};
exports.saveInitialData = saveInitialData;
const getAccessToken = () => {
    return (0, exports.getInitialData)().accessToken;
};
exports.getAccessToken = getAccessToken;
const updateAccessToken = (accessToken) => {
    let updatedInitialData = (0, exports.getInitialData)();
    updatedInitialData.accessToken = accessToken;
    (0, utils_1.appLog)("Access token updated");
    (0, exports.saveInitialData)(updatedInitialData);
};
exports.updateAccessToken = updateAccessToken;
const getInitialData = () => {
    return JSON.parse(fs_1.default.readFileSync(storagePath + storageFile).toString());
};
exports.getInitialData = getInitialData;
